// Program: Lesson 22 - Excercise 4

#include <iostream.h>

class set
 {
public:
	void clear(void);
	void add(float num);
	int exist(float num);
private:
	set* next;
	float element;
 };

void set::clear(void)
 {
	next = NULL;
 }

void set::add(float num)
 {
	if (!exist(num))
	 {
	   // create a new set element and link it to the set,
	   // update the NEXT pointer to include the new link
		next = new set;
	   next->element = num;
		next->next = NULL;
	 }
 }

int set::exist(float num)
 {
	// go over all set elements, and look for NUM
	set* iterator = next;
	while (iterator)
	{
		if (next->element == num) return 1;
		iterator = iterator->next;
	}
	return 0;
 }

void main(void)
 {
	set s;
	s.clear();
	s.add(10);
	s.add(10);
	s.add(6.7);
	cout << "6.7 exists: " << s.exist(6.7) << endl;
	cout << "11 exists: " << s.exist(11) << endl;
 }
