// Program: Lesson 23, Exercise 1

#include <iostream.h>

class Key {
 public:
   Key(void); // Constructor method -- no return type
   Key(long);
   void set(void);
   void certificate(void);

 private:
   int  check(void);    
   long the_key;
 };

Key::Key(void)
 {
   the_key = -1;
 }

Key::Key(long the_key)
 {
   Key::the_key = the_key;
 }

void Key::set(void)
 {
   long new_key;

   if ((the_key == -1) || (check() == 1))
    {
     do {
         cout << "please enter new secret key: ";
         cin >> new_key;
        }
     while (new_key < 0);
     the_key = new_key;
    }
 }

int Key::check(void)
 {
   long answer;

   if (the_key == -1)
    {
     cout << "sorry, you have to initialize your key first" << endl;
     return -1;
    }

   cout << "please enter your secret key: ";
   cin >> answer;

   if (answer == the_key)
    {
     cout << "OK!" << endl;
     return 1;
    }
   else
    {
     cout << "Wrong key!!" << endl;
     return -1;
    }
 }

void Key::certificate(void)
 {

   if (check() == 1)
    {   
     cout << "**************************************************" << endl;
     cout << "The holder of this certificate is the" << endl;
     cout << "rightful owner of key " << the_key << "." << endl;
     cout << "**************************************************" << endl;
    }
 }

void main(void)
 {
    Key my_key;

    my_key.set();
    my_key.set();
    my_key.certificate();
 }
