// Program: Lesson 28 - Excercise 4

#include <string.h>

class book;
class borrowed_book;

class librarian {
 public:
   void change_catalog(book *, char *);
   char *get_catalog(book);
	void borrow_book(borrowed_book* book, char* borrower);
	void return_book(borrowed_book *book);
};
class book {
 public:
   book(char *, char *, char *);
   void show_book(void);
	friend char *librarian::get_catalog(book);
	friend void librarian::change_catalog(book *, char *);
 private:
   char title[64];
   char author[64];
   char catalog[64];
};
class borrowed_book : public book
 {
	public:
		borrowed_book(char* title, char* author, char* catalog, char* newborrower, int days)
					: book (title, author, catalog)
		{
			strcpy (borrower_name,newborrower);
			borrow_days = days;
		}
		void borrow_book(borrowed_book* book, char* borrower);
		void return_book(borrowed_book* book);
	private:
		char borrower_name[80];
		int  borrow_days;
 };
