// Program: Lesson 38, Exercise 5

#include <iostream.h>
#include <math.h>

class shape {
 public:
   virtual float area(void) =0;
   virtual float circumference(void) =0;
   virtual int is_in (float x, float y) =0;
 };

class position {
 public:
   position(void)                               { my_x = my_y = 0; }
   void set_position (float x = 0, float y = 0) { my_x = x; my_y = y; }
   void move (float dx = 0, float dy = 0)       { my_x = my_x + dx;
						  my_y = my_y + dy; }
 protected:
   float my_x;
   float my_y;
 };

class circle : public shape, public position
 {
  public:
    circle(float radius)          { circle :: radius = radius; }
    void set_radius(float radius) { circle :: radius = radius; }
    float area(void)              { return M_PI * radius * radius; }
    float circumference(void)     { return 2 * M_PI * radius; }
    int is_in (float x, float y)  { return sqrt(pow((x - my_x),2) +
						pow((y - my_y),2))
						<= radius; }

  private:
    float radius;
 };

void main(void)
 {
   circle* c = new circle(3);
   c -> set_position(1,1);
   c -> move (0, -1);

   cout << "is (0,0) in circle? " << c -> is_in(0,0) << endl;
   cout << "is (5,-3) in circle? " << c -> is_in(5,-3) << endl;
   cout << "area = " << c -> area() << endl;
   cout << "circumference = " << c -> circumference() << endl;
 }



