// Program: Lesson exception - Excercise 1

#include <iostream.h>

template <class T>
class array 
 {
 public:
    array(int size);
    ~array();
    T& operator[](unsigned int index);
 
 private:
    T*  data;
    int num;
 };

template <class T>
array<T>::array(int size)
 {
     data=new T[size];
     num=size;
 }
template <class T>
array<T>::~array()
 {
     delete data;
 }
template <class T>
T& array<T>::operator[](unsigned int index)
 {
     if (index>=num) throw "access violation error";
     return data[index];
 }


void main(void)
 {
    array<int> a(100);
    try {
	a[1]=2;
	a[101]=3;
    }
    catch (char* s) {
      cerr << "Exception: " << s;
    }
 }
