#include <iostream.h>

class circle
	{
		private:
			int radius;
		public:
			circle(int r) {radius = r;}
			circle() {radius = 0;}
			circle &operator++();     
			circle operator++(int);
			void show() { cout << "radius = " << radius << endl; }
	};

circle &circle::operator++() // pre increment
	{          
		radius++;
		return *this;
	}

circle circle::operator++(int)  // post increment 
	{						// the (int) is just for the different between pre and post
		circle tmp = *this;   
		radius++;               
		return tmp;         // before the post action
	}

void main(void)
	{
		circle c1(3), c2;

		cout << "c1 first: ";
		c1.show();
		cout << "c2 = c1++: ";
		c2 = c1++;
		c2.show();
		cout << "c2 = ++c1: ";
		c2 = ++c1;
		c2.show();
	}

