// Program: Lesson 28 - Excercise 2

#include <iostream.h>

class complex
{
 public:
	complex(float real=0, float imaginary=0) { re = real;
						   im = imaginary; }
	complex& operator=(const complex& c)     { re = c.re; im = c.im;
						   return *this; }
	void print(void) { cout << re << "+" << im << "i" << endl; }

	friend complex operator+(complex& c, float f);
	friend complex operator+(float f, complex& c);

  private:
	float re, im;
 };

complex operator+(complex& c, float f)
 {
	complex result = c;
	result.re += f;
	return result;
 }

complex operator+(float f, complex& c)
 {
	return c+f;
 }


void main(void)
 {
	float f=3;
	complex c(1,2), result;
	result=f+c;
	result=c+f;
	c.print();
	result.print();
 }