// Program: Lesson 32 - Excercise 1

#include <iostream.h>
#include <stdlib.h>

static int new_invocations = 0;
static int delete_invocations = 0;

static void *operator new(size_t size)
 {
	new_invocations++;
	return malloc(size);
  }

static void operator delete(void* ptr)
 {
	delete_invocations++;
	free(ptr);
 }

void main(void)
 {
	char* s = new char[60];
	delete []s;

	if (delete_invocations != new_invocations)
	  cout << "Memory leak warning!!";

	s = new char[60];
	if (delete_invocations != new_invocations)
	  cout << "Memory leak warning!!";
 }


