// Program: Lesson 34 - Excercise 3

#include <iostream.h>
#include <fstream.h>
#include <string.h>

class person {
 public:
	person(char* first, char* last, int person_age);
	void   print(void);
	friend ostream& operator<<(ostream& i, person& p);
	friend istream& operator>>(istream& o, person& p);
 private:
	char firstname[80];
	char lastname[80];
	int age;
 };


person::person(char* first, char* last, int person_age)
 {
	strcpy(firstname, first);
	strcpy(lastname, last);
	age = person_age;
 }

void person::print(void)
 {
    cout << firstname << " " << lastname << " is " << age
	 << " years old" << endl;
 }

ostream& operator<<(ostream& o, person& p)
 {
	o << p.firstname << endl << p.lastname << endl << p.age;
	return o;
 }

istream& operator>>(istream& i, person& p)
{
	i.getline(p.firstname, 80);
	i.getline(p.lastname, 80);
	i >> p.age;
	return i;
}

void main(void)
 {
   person p1("indy", "jones", 36);
   person p2("union", "jack", 11);
   ofstream o("test.dat");
   o << p1;
	o << p2;
	o.close();
   ifstream i("test.dat");
   i >> p1;
   i >> p2;
   p1.print();
	p2.print();
	i.close();
 }
