#include <iostream.h>
#include <string.h>

class number
	{
		private:	
			float f;
		public:
			number *next;
			number(float f1){ next = NULL; f = f1; }
			void add (number *new_block)
			{
					next = new_block;
			} 
			void show(){ cout << "f = " << f << "  "; }
	};

class string_
	{
		private:
			char s[100];
		public:
			string_ *next;
			string_(const char *str)
				{
					next = NULL;
					strcpy(s, str);
				}
			void add(string_ *new_block)
				{
					next = new_block;
				}
			void show(){ cout << "s = " << s << "  "; }
	};


template <class T>
class list
	{
		private:
			T *head;
			T *tail;
		public:
			list(void)
			{
				head = NULL; 
				tail = NULL;
			}
			void add(T *new_block);
			void print();
	};


template <class T>
void list<T>::add(T *new_block)
	{
		if (head == NULL)
			head = new_block;
		else
			tail->add(new_block);

		tail = new_block;
	}

template <class T>
void list<T>::print()
	{
		T *tmp; 

		for (tmp = head; tmp != NULL; tmp = tmp->next)
			tmp->show();
	}

void main(void)
	{
		number *np;
		string_ *sp;
		list <number> number_list;
		list <string_> string_list;
		char word[100];
		float fn;

		cout << "Enter a float number and a word:\n";
		for (int i = 0; i < 3; i++)
			{
				cin >> fn >> word;
				np = new number(fn);
				sp = new string_(word);
				number_list.add(np);
				string_list.add(sp);
			}
		number_list.print();
		cout << endl;
		string_list.print();
	}
